Set Step On
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
* --- Eddy Maue
* --- Cre le : 2018-09-03
* --- libre de droit avec une restriction
* --- -     que cette entte demeure
* ---
* --- DeclarVar_install.prg
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
#Define true    .T.
#Define false    .F.
#Define IsTrue = true
#Define IsFalse = false
#Define SetTrue  Store true To
#Define SetFalse Store false To

#Define FILE_DECLARE_VAR "DeclarVar_cmd.prg"
#Define FILE_ALL_BASE_TYPE "declarevar_insertiontype.prg"
#Define RECORD_DeclareVar  'DeclareVar'

* --------------------------------------------------------------------------------
Local cCurrPath
cCurrPath = Set("Path")

* --------------------------------------------------------------------------------
Local lcCheminCourant As Character
lcCheminCourant = Sys(2003)

* --------------------------------------------------------------------------------
Local Success As logical
m.Success = .T.

* --------------------------------------------------------------------------------
* SET DEFAUT TO est similaire CD()   ---------------------------------------------
* repertoire ou sont les 3 fichiers  ---------------------------------------------
* --------------------------------------------------------------------------------
Cd (Justpath(Substr(Sys(16),Iif(Sys(16)="PROCEDURE",At(":",Sys(16))-2,1))))

Do Case

        * --------------------------------------------------------------------------------
    Case Empty(_Foxcode) IsTrue
        SetFalse m.Success
        Messagebox(" Pour poursuivre '_foxcode' doit etre renseingn",0+16,"Variable systeme...")
        * --------------------------------------------------------------------------------
    Case File(_Foxcode) IsFalse
        SetFalse m.Success
        Messagebox("_foxcode est mal renseign",0+16,"Variable systeme...")
        * --------------------------------------------------------------------------------
    Case CopieDEfoxcode(_Foxcode) IsFalse
        * --------------------------------------------------------------------------------
        * ----  production d'une copie de la table foxcode  ------------------------------
        * --------------------------------------------------------------------------------
        Success IsFalse

    Case Install_cmd_DeclarVar() IsFalse
        Success IsFalse


    Case Install_all_base_type() IsFalse
        Success IsFalse

    Otherwise

        Messagebox("temin",48)

Endcase



*  / Install_cmd_DeclarVar
* / Eddy Maue a+  --   Crer le : 2018-09-03
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
Procedure Install_cmd_DeclarVar()

    Local Success As logical
    m.Success = .T.

    Local lcfichier2install As Character
    lcfichier2install = FILE_DECLARE_VAR

    Local lcTblCible As Character
    lcTblCible = Juststem(_Foxcode)

    Local lsDATA As String

    Do Case

        Case Success IsFalse

            * --------------------------------------------------------------------------------
        Case File(m.lcfichier2install ) IsFalse

            Assert .F. Message "le fichier" + m.lcfichier2install+ " n'est pas prsent ou n'est pas accessible"
            SetFalse Success

            * --------------------------------------------------------------------------------
        Case UseTable(_Foxcode) IsFalse
            Assert .F. Message 'ou est pass la table foxcode'
            SetFalse sucess


        Otherwise
            * --------------------------------------------------------------------------------
            * --------------------------------------------------------------------------------

            lsDATA = Filetostr(m.lcfichier2install)



            * --------------------------------------------------------------------------------
            Select (m.lcTblCible)
            
            Locate For lower(abbrev) = Padr(Lower(RECORD_DeclareVar),Fsize('abbrev'))
            If Not Found()

                _Tally = 0


                * --------------------------------------------------------------------------------
                * --------------------------------------------------------------------------------

                Local loFoxcodeField As Empty
                m.loFoxcodeField = Createobject("empty")

                AddProperty(m.loFoxcodeField ,"Type"     , "S" )
                AddProperty(m.loFoxcodeField ,"Save"     , .T. )

                * champs qui vont voluer en cours d'insertions
                AddProperty(m.loFoxcodeField ,"Abbrev"   , "DeclareVar" )
                AddProperty(m.loFoxcodeField ,"Timestamp", Datetime() )
                AddProperty(m.loFoxcodeField ,"Uniqueid" , Sys(2015) )

                Insert Into (m.lcTblCible)  From Name m.loFoxcodeField

                * --------------------------------------------------------------------------------
                If _Tally =0 IsTrue
                    SetFalse Success
                    Assert .F. Message "l'insertion ne c'est pas faite adquatement"

                Endif

            Endif



    Endcase

    Return Success

Endproc && Install_cmd_DeclarVar

*  / UseFoxCode
* / Eddy Maue a+  --   Crer le : 2018-09-03
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
Procedure UseTable(tcFichier)

    Local lcFichier As Character
    lcFichier=m.tcFichier

    Local lcTable As Character
    lcTable = Juststem(m.tcFichier)


    Local Success
    m.Success = true

    Do Case
        Case File(m.tcFichier) IsFalse
            SetFalse Success

        Case Used(m.lcTable)
        Otherwise
            * --------------------------------------------------------------------------------
            * --------------------------------------------------------------------------------
            Select 0
            Use (m.tcFichier)

    Endcase

    * --------------------------------------------------------------------------------
    If Success
        Select(m.tcFichier)
    Endif

    Return Success
Endproc && UseFoxCode




*  / Install_all_base_type
* / Eddy Maue a+  --   Crer le : 2018-09-03
* --------------------------------------------------------------------------------
* --------------------------------------------------------------------------------
Procedure Install_all_base_type

    Local Success As logical
    m.Success = .T.

    Do Case
            * --------------------------------------------------------------------------------
        Case File(FILE_ALL_BASE_TYPE) IsFalse
            SetFalse Success

        Otherwise
            * --------------------------------------------------------------------------------
            * --------------------------------------------------------------------------------

            Do (FILE_ALL_BASE_TYPE)

    Endcase

    Return Success

Endproc && Install_all_base_type





*  / CopieDEfoxcode
* / Eddy Maue a+  --   Crer le : 2018-09-03
Procedure CopieDEfoxcode (tcFichier)

    Local Success As logical
    m.Success = .T.



    Local  OE As Exception
    Try
        Local lcChemin As Character
        lcChemin = Justpath(m.tcFichier)

        Local lcNom As Character
        lcNom = Juststem(m.tcFichier)

        Local lcCheminCourant As Character
        lcCheminCourant = Sys(2003)




        Local lcDatetime As String
        lcDatetime = " "+ Transform(Dtos(Date()))  +  '('+Chrtran(Trans(Time()),':','-')+')'


        Do Case

            Case UseTable(_Foxcode) IsFalse
                Assert .F. Message 'ou est pass la table foxcode'
                SetFalse sucess


            Otherwise


                * --------------------------------------------------------------------------------
                * ajout d'un compteur au cas ou le fichier existe---------------------------------
                Local ii As Integer
                ii = 0

                Local lcNewFile As Character
                lcNewFile  = Addbs(m.lcChemin) +m.lcNom + lcDatetime+'.dbf'

                * --------------------------------------------------------------------------------
                Do While File(m.lcNewFile) IsTrue
                    ii = ii + 1
                    lcNewFile  = m.lcChemin +m.lcNom + lcDatetime+'+Transform(ii).dbf'

                Enddo

                * production de la copie de foxcode-----------------------------------------------
                * --------------------------------------------------------------------------------
                _Foxcode = ""
                Cd (m.lcChemin)
                _Tally = 0

                * --------------------------------------------------------------------------------
                Select * From (m.lcNom) Into Table (
                * --------------------------------------------------------------------------------
                If _Tally = 0
                    SetFalse Success
                    Assert .F. Message "la copie n'a t faite avec succes"
                Endif

                Use in (JustStem(m.lcNewFile))
        Endcase



    Catch To OE

        _Cliptext = ;
            "Erreur no    ="+ Transform(OE.ErrorNo)+cr2+;
            "Message      ="+OE.Message+cr2+;
            "LineContents ="+OE.LineContents+cr+;
            "Detail       ="+OE.Details+cr2

        Assert .F. Message _Cliptext

        SetFalse Success


    Finally

        * --------------------------------------------------------------------------------
        * --------------------------------------------------------------------------------
        _Foxcode = m.tcFichier
        Cd(m.lcCheminCourant)

    Endtry


    Return Success












